import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { UserBalanceInMerchant, UserBalanceInMerchantParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询用户在商家中的余额
 */
export async function pageUserBalanceInMerchant(params: UserBalanceInMerchantParam) {
  const res = await request.get<ApiResult<PageResult<UserBalanceInMerchant>>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询用户在商家中的余额列表
 */
export async function listUserBalanceInMerchant(params?: UserBalanceInMerchantParam) {
  const res = await request.get<ApiResult<UserBalanceInMerchant[]>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加用户在商家中的余额
 */
export async function addUserBalanceInMerchant(data: UserBalanceInMerchant) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户在商家中的余额
 */
export async function updateUserBalanceInMerchant(data: UserBalanceInMerchant) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除用户在商家中的余额
 */
export async function removeUserBalanceInMerchant(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除用户在商家中的余额
 */
export async function removeBatchUserBalanceInMerchant(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询用户在商家中的余额
 */
export async function getUserBalanceInMerchant(id: number) {
  const res = await request.get<ApiResult<UserBalanceInMerchant>>(
    MODULES_API_URL + '/shop/user-balance-in-merchant/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
